Skip to content
Start here

Rate Limits

List rate limits
Deprecated
client.RateLimits.List(ctx, params) (*V4PagePaginationArray[RateLimit], error)
GET/zones/{zone_id}/rate_limits
Get a rate limit
Deprecated
client.RateLimits.Get(ctx, rateLimitID, query) (*RateLimit, error)
GET/zones/{zone_id}/rate_limits/{rate_limit_id}
Create a rate limit
Deprecated
client.RateLimits.New(ctx, params) (*RateLimit, error)
POST/zones/{zone_id}/rate_limits
Update a rate limit
Deprecated
client.RateLimits.Edit(ctx, rateLimitID, params) (*RateLimit, error)
PUT/zones/{zone_id}/rate_limits/{rate_limit_id}
Delete a rate limit
Deprecated
client.RateLimits.Delete(ctx, rateLimitID, body) (*RateLimitDeleteResponse, error)
DELETE/zones/{zone_id}/rate_limits/{rate_limit_id}
ModelsExpand Collapse
type Action string

The action to apply to a matched request. The log action is only available on an Enterprise plan.

One of the following:
const ActionBlock Action = "block"
const ActionChallenge Action = "challenge"
const ActionJSChallenge Action = "js_challenge"
const ActionManagedChallenge Action = "managed_challenge"
const ActionAllow Action = "allow"
const ActionLog Action = "log"
const ActionBypass Action = "bypass"
type RateLimit struct{…}
ID stringoptional

The unique identifier of the rate limit.

maxLength32
Action RateLimitActionoptional

The action to perform when the threshold of matched traffic within the configured period is exceeded.

Mode RateLimitActionModeoptional

The action to perform.

One of the following:
const RateLimitActionModeSimulate RateLimitActionMode = "simulate"
const RateLimitActionModeBan RateLimitActionMode = "ban"
const RateLimitActionModeChallenge RateLimitActionMode = "challenge"
const RateLimitActionModeJSChallenge RateLimitActionMode = "js_challenge"
const RateLimitActionModeManagedChallenge RateLimitActionMode = "managed_challenge"
Response RateLimitActionResponseoptional

A custom content type and reponse to return when the threshold is exceeded. The custom response configured in this object will override the custom error for the zone. This object is optional. Notes: If you omit this object, Cloudflare will use the default HTML error page. If "mode" is "challenge", "managed_challenge", or "js_challenge", Cloudflare will use the zone challenge pages and you should not provide the "response" object.

Body stringoptional

The response body to return. The value must conform to the configured content type.

maxLength10240
ContentType stringoptional

The content type of the body. Must be one of the following: text/plain, text/xml, or application/json.

maxLength50
Timeout float64optional

The time in seconds during which Cloudflare will perform the mitigation action. Must be an integer value greater than or equal to the period. Notes: If "mode" is "challenge", "managed_challenge", or "js_challenge", Cloudflare will use the zone's Challenge Passage time and you should not provide this value.

maximum86400
minimum1
Bypass []RateLimitBypassoptional

Criteria specifying when the current rate limit should be bypassed. You can specify that the rate limit should not apply to one or more URLs.

Name RateLimitBypassNameoptional
Value stringoptional

The URL to bypass.

Description stringoptional

An informative summary of the rule. This value is sanitized and any tags will be removed.

maxLength1024
Disabled booloptional

When true, indicates that the rate limit is currently disabled.

Match RateLimitMatchoptional

Determines which traffic the rate limit counts towards the threshold.

Headers []RateLimitMatchHeaderoptional
Name stringoptional

The name of the response header to match.

Op RateLimitMatchHeadersOpoptional

The operator used when matching: eq means "equal" and ne means "not equal".

One of the following:
const RateLimitMatchHeadersOpEq RateLimitMatchHeadersOp = "eq"
const RateLimitMatchHeadersOpNe RateLimitMatchHeadersOp = "ne"
Value stringoptional

The value of the response header, which must match exactly.

Request RateLimitMatchRequestoptional
Methods []RateLimitMatchRequestMethodoptional

The HTTP methods to match. You can specify a subset (for example, ['POST','PUT']) or all methods (['_ALL_']). This field is optional when creating a rate limit.

One of the following:
const RateLimitMatchRequestMethodGet RateLimitMatchRequestMethod = "GET"
const RateLimitMatchRequestMethodPost RateLimitMatchRequestMethod = "POST"
const RateLimitMatchRequestMethodPut RateLimitMatchRequestMethod = "PUT"
const RateLimitMatchRequestMethodDelete RateLimitMatchRequestMethod = "DELETE"
const RateLimitMatchRequestMethodPatch RateLimitMatchRequestMethod = "PATCH"
const RateLimitMatchRequestMethodHead RateLimitMatchRequestMethod = "HEAD"
const RateLimitMatchRequestMethod_All RateLimitMatchRequestMethod = "_ALL_"
Schemes []stringoptional

The HTTP schemes to match. You can specify one scheme (['HTTPS']), both schemes (['HTTP','HTTPS']), or all schemes (['_ALL_']). This field is optional.

URL stringoptional

The URL pattern to match, composed of a host and a path such as example.org/path*. Normalization is applied before the pattern is matched. * wildcards are expanded to match applicable traffic. Query strings are not matched. Set the value to * to match all traffic to your zone.

maxLength1024
Response RateLimitMatchResponseoptional
OriginTraffic booloptional

When true, only the uncached traffic served from your origin servers will count towards rate limiting. In this case, any cached traffic served by Cloudflare will not count towards rate limiting. This field is optional. Notes: This field is deprecated. Instead, use response headers and set "origin_traffic" to "false" to avoid legacy behaviour interacting with the "response_headers" property.

Period float64optional

The time in seconds (an integer value) to count matching traffic. If the count exceeds the configured threshold within this period, Cloudflare will perform the configured action.

maximum86400
minimum10
Threshold float64optional

The threshold that will trigger the configured mitigation action. Configure this value along with the period property to establish a threshold per period.

minimum1